<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../">
  <title data-ice="title">src/Wizard.unit.js | formiojs</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="JavaScript powered Forms with JSON Form Builder"><meta property="twitter:card" content="summary"><meta property="twitter:title" content="formiojs"><meta property="twitter:description" content="JavaScript powered Forms with JSON Form Builder"></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/atorico.com/formio/formio.js.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/EventEmitter.js~EventEmitter.html">EventEmitter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/Form.js~Form.html">Form</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/FormBuilder.js~FormBuilder.html">FormBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/PDFBuilder.js~PDFBuilder.html">PDFBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/WizardBuilder.js~WizardBuilder.html">WizardBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-embed">embed</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#builders">builders</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/builders/Builders.js~Builders.html">Builders</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components">components</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/Components.js~Components.html">Components</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component">components/_classes/component</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Component">Component</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component-editform">components/_classes/component/editForm</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-EditFormUtils">EditFormUtils</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-componentmodal">components/_classes/componentModal</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/componentModal/ComponentModal.js~ComponentModal.html">ComponentModal</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-field">components/_classes/field</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/field/Field.js~Field.html">Field</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-nested">components/_classes/nested</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/nested/NestedComponent.js~NestedComponent.html">NestedComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-NestedComponent">NestedComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-address">components/address</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Address">Address</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-button">components/button</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Button">Button</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-checkbox">components/checkbox</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/checkbox/Checkbox.js~CheckBoxComponent.html">CheckBoxComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Checkbox">Checkbox</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-columns">components/columns</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/columns/Columns.js~ColumnsComponent.html">ColumnsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Columns">Columns</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-container">components/container</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/container/Container.js~ContainerComponent.html">ContainerComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Container">Container</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-content">components/content</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/content/Content.js~ContentComponent.html">ContentComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Content">Content</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-currency">components/currency</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/currency/Currency.js~CurrencyComponent.html">CurrencyComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Currency">Currency</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datagrid">components/datagrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataGrid">DataGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datamap">components/datamap</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datamap/DataMap.js~DataMapComponent.html">DataMapComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataMap">DataMap</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datetime">components/datetime</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datetime/DateTime.js~DateTimeComponent.html">DateTimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DateTime">DateTime</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-day">components/day</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Day">Day</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-editgrid">components/editgrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditGrid">EditGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-email">components/email</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/email/Email.js~EmailComponent.html">EmailComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Email">Email</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-fieldset">components/fieldset</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/fieldset/Fieldset.js~FieldsetComponent.html">FieldsetComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Fieldset">Fieldset</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-file">components/file</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-File">File</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-form">components/form</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Form">Form</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-hidden">components/hidden</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/hidden/Hidden.js~HiddenComponent.html">HiddenComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Hidden">Hidden</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-html">components/html</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/html/HTML.js~HTMLComponent.html">HTMLComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-HTML">HTML</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-number">components/number</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/number/Number.js~NumberComponent.html">NumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Number">Number</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-panel">components/panel</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Panel">Panel</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-password">components/password</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/password/Password.js~PasswordComponent.html">PasswordComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Password">Password</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-phonenumber">components/phonenumber</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/phonenumber/PhoneNumber.js~PhoneNumberComponent.html">PhoneNumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-PhoneNumber">PhoneNumber</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-radio">components/radio</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/radio/Radio.js~RadioComponent.html">RadioComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Radio">Radio</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-recaptcha">components/recaptcha</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/recaptcha/ReCaptcha.js~ReCaptchaComponent.html">ReCaptchaComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ReCaptcha">ReCaptcha</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-resource">components/resource</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/resource/Resource.js~ResourceComponent.html">ResourceComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Resource">Resource</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select">components/select</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Select">Select</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select-fixtures">components/select/fixtures</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelect">multiSelect</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelectOptions">multiSelectOptions</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-selectboxes">components/selectboxes</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-SelectBoxes">SelectBoxes</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-signature">components/signature</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/signature/Signature.js~SignatureComponent.html">SignatureComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Signature">Signature</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-survey">components/survey</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Survey">Survey</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-table">components/table</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/table/Table.js~TableComponent.html">TableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Table">Table</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tabs">components/tabs</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tabs/Tabs.js~TabsComponent.html">TabsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tabs">Tabs</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tags">components/tags</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tags/Tags.js~TagsComponent.html">TagsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tags">Tags</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textarea">components/textarea</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextArea">TextArea</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textfield">components/textfield</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextField">TextField</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-time">components/time</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/time/Time.js~TimeComponent.html">TimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Time">Time</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tree">components/tree</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tree/Node.js~Node.html">Node</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tree">Tree</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-unknown">components/unknown</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/unknown/Unknown.js~UnknownComponent.html">UnknownComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Unknown">Unknown</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-url">components/url</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/url/Url.js~UrlComponent.html">UrlComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Url">Url</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-well">components/well</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/well/Well.js~WellComponent.html">WellComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Well">Well</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib">contrib</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Contrib">Contrib</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-edittable">contrib/edittable</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/edittable/EditTable.js~EditTableComponent.html">EditTableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditTable">EditTable</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-location">contrib/location</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/location/Location.js~LocationComponent.html">LocationComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Location">Location</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-modaledit">contrib/modaledit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/modaledit/ModalEdit.js~ModalEditComponent.html">ModalEditComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ModalEdit">ModalEdit</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-checkout">contrib/stripe/checkout</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/checkout/StripeCheckout.js~StripeCheckoutComponent.html">StripeCheckoutComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-stripe">contrib/stripe/stripe</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/stripe/Stripe.js~StripeComponent.html">StripeComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#displays">displays</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/displays/Displays.js~Displays.html">Displays</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers">providers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/Providers.js~Providers.html">Providers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-address">providers/address</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AddressProvider.js~AddressProvider.html">AddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AzureAddressProvider.js~AzureAddressProvider.html">AzureAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/CustomAddressProvider.js~CustomAddressProvider.html">CustomAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/NominatimAddressProvider.js~NominatimAddressProvider.html">NominatimAddressProvider</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-processor">providers/processor</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-fileProcessor">fileProcessor</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-storage">providers/storage</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-azure">azure</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-base64">base64</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-dropbox">dropbox</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-indexeddb">indexeddb</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-s3">s3</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getFormioUploadAdapterPlugin">getFormioUploadAdapterPlugin</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-url">url</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-setXhrHeaders">setXhrHeaders</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-XHR">XHR</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates">templates</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/templates/Templates.js~Templates.html">Templates</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates-bootstrap">templates/bootstrap</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-iconClass">iconClass</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils">utils</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/utils/ChoicesWrapper.js~ChoicesWrapper.html">ChoicesWrapper</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-checkInvalidDate">checkInvalidDate</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-lessOrGreater">lessOrGreater</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-applyFormChanges">applyFormChanges</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-eachComponent">eachComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-escapeRegExCharacters">escapeRegExCharacters</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponent">findComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponents">findComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-flattenComponents">flattenComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-formatAsCurrency">formatAsCurrency</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-generateFormChange">generateFormChange</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getComponent">getComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getStrings">getStrings</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getValue">getValue</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-hasCondition">hasCondition</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-isLayoutComponent">isLayoutComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-matchComponent">matchComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-parseFloatExt">parseFloatExt</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-removeComponent">removeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-searchComponents">searchComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-KEY_CODES">KEY_CODES</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Evaluator">Evaluator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CALENDAR_ERROR_MESSAGES">CALENDAR_ERROR_MESSAGES</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils-jsonlogic">utils/jsonlogic</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-lodashOperators">lodashOperators</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#validator">validator</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Rules.js~Rules.html">Rules</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Validator.js~ValidationChecker.html">ValidationChecker</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#widgets">widgets</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/widgets/InputWidget.js~InputWidget.html">InputWidget</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/Wizard.unit.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import Harness from &apos;../test/harness&apos;;
import Wizard from &apos;./Wizard&apos;;
import Formio from &apos;./Formio&apos;;
import assert from &apos;power-assert&apos;;
import _ from &apos;lodash&apos;;
import wizardCond from &apos;../test/forms/wizardConditionalPages&apos;;
import wizard from &apos;../test/forms/wizardValidationOnPageChanged&apos;;
import wizard1 from &apos;../test/forms/wizardValidationOnNextBtn&apos;;
import wizard2 from &apos;../test/forms/wizardWithEditGrid&apos;;
import wizard3 from &apos;../test/forms/conditionalWizardPages&apos;;
import wizard4 from &apos;../test/forms/wizardWithSimpleConditionalPage&apos;;
import wizard5 from &apos;../test/forms/wizardWithCustomConditionalPage&apos;;
import wizard6 from &apos;../test/forms/wizardWithFirstConditionalPage&apos;;
import wizardWithHighPages from &apos;../test/forms/wizardWithHighPages&apos;;
import wizardWithHiddenPanel from &apos;../test/forms/wizardWithHiddenPanel&apos;;
import wizardWithAllowPrevious from &apos;../test/forms/wizardWithAllowPrevious&apos;;
import wizardWithNestedWizard from &apos;../test/forms/wizardWithNestedWizard&apos;;
import formWithSignature from &apos;../test/forms/formWithSignature&apos;;
import wizardWithTooltip from &apos;../test/forms/wizardWithTooltip&apos;;
import wizardForHtmlModeTest from &apos;../test/forms/wizardForHtmlRenderModeTest&apos;;
import wizardTestForm from &apos;../test/forms/wizardTestForm&apos;;
import formWithNestedWizard from &apos;../test/forms/formWIthNestedWizard&apos;;
import wizardWithDataGridAndEditGrid from &apos;../test/forms/wizardWithDataGridAndEditGrid&apos;;
import customWizard from &apos;../test/forms/customWizard&apos;;
import wizardChildForm from &apos;../test/forms/wizardChildForm&apos;;
import wizardParentForm from &apos;../test/forms/wizardParentForm&apos;;

describe(&apos;Wizard tests&apos;, () =&gt; {
  it(&apos;Should correctly reset values&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);

    wizard.setForm(wizardWithDataGridAndEditGrid).then(() =&gt; {
      const dataGrid = wizard.getComponent(&apos;dataGrid&apos;);
      const editGrid = wizard.getComponent(&apos;editGrid&apos;);

      const checkComponents = (editGridRowsNumber, dataGridRowsNumber, editGridValue, dataGridValue) =&gt; {
        assert.equal(editGrid.editRows.length, editGridRowsNumber, `EditGrit should have ${dataGridRowsNumber} rows`);
        assert.equal(editGrid.components.length, editGridRowsNumber, `EditGrit should have ${dataGridRowsNumber} components`);
        assert.equal(dataGrid.rows.length, dataGridRowsNumber, `DataGrit should have ${dataGridRowsNumber} rows`);
        assert.equal(dataGrid.components.length, dataGridRowsNumber, `DataGrit should have ${dataGridRowsNumber} components`);

        if (editGridValue) {
          assert.deepEqual(editGrid.dataValue, editGridValue, &apos;Should set correct editGrid value&apos;);
        }

        if (dataGridValue) {
          assert.deepEqual(dataGrid.dataValue, dataGridValue, &apos;Should set correct dataGrid value&apos;);
        }
      };

      const event = (name, elem) =&gt; {
        const event = new Event(name);
        elem.dispatchEvent(event);
      };

      checkComponents(0, 1, [], [{}]);

      const submission = {
          data: {
            dataGrid: [{ number: 1111 }, { number: 2222 }],
            editGrid: [{ textField: &apos;test1&apos; }, { textField: &apos;test2&apos; }]
        }
      };

      wizard.submission = _.cloneDeep(submission);

      setTimeout(() =&gt; {
        checkComponents(2, 2,  submission.data.editGrid,submission.data.dataGrid);
        wizard.cancel(true);

        setTimeout(() =&gt; {
          checkComponents(0, 1, [], [{}]);
          event(&apos;click&apos;, editGrid.refs[&apos;editgrid-editGrid-addRow&apos;][0]);

          setTimeout(() =&gt; {
            const editGridFirstRowInput = editGrid.element.querySelector(&apos;[name=&quot;data[editGrid][0][textField]&quot;]&apos;);
            editGridFirstRowInput.value = &apos;test row 1&apos;;
            event(&apos;input&apos;, editGridFirstRowInput);
            event(&apos;click&apos;, editGrid.refs[&apos;editgrid-editGrid-saveRow&apos;][0]);

            const dataGridFirstRowInput = dataGrid.element.querySelector(&apos;[name=&quot;data[dataGrid][0][number]&quot;]&apos;);
            dataGridFirstRowInput.value = 11;
            event(&apos;input&apos;, dataGridFirstRowInput);

            setTimeout(() =&gt; {
              checkComponents(1, 1,  [{ textField:&apos;test row 1&apos; }], [{ number: 11 }]);

              event(&apos;click&apos;, editGrid.refs[&apos;editgrid-editGrid-addRow&apos;][0]);
              event(&apos;click&apos;, dataGrid.refs[&apos;datagrid-dataGrid-addRow&apos;][0]);

              setTimeout(() =&gt; {
                const editGridFirstRowInput = editGrid.element.querySelector(&apos;[name=&quot;data[editGrid][1][textField]&quot;]&apos;);
                editGridFirstRowInput.value = &apos;test row 2&apos;;
                event(&apos;input&apos;, editGridFirstRowInput);
                event(&apos;click&apos;, editGrid.refs[&apos;editgrid-editGrid-saveRow&apos;][0]);

                const dataGridFirstRowInput = dataGrid.element.querySelector(&apos;[name=&quot;data[dataGrid][1][number]&quot;]&apos;);
                dataGridFirstRowInput.value = 22;
                event(&apos;input&apos;, dataGridFirstRowInput);

                setTimeout(() =&gt; {
                  const editGridValue = [{ textField:&apos;test row 1&apos; }, { textField:&apos;test row 2&apos; }];
                  const dataGridValue  = [{ number: 11 }, { number: 22 }];

                  checkComponents(2, 2, editGridValue, dataGridValue);

                  assert.deepEqual(wizard.submission.data, {
                    dataGrid: dataGridValue,
                    editGrid: editGridValue
                  }, &apos;Should contain correct submission data&apos;);

                  done();
                }, 200);
              }, 200);
            }, 200);
          }, 200);
        }, 200);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  }).timeout(2500);

  it(&apos;Should render nested wizard, navigate pages and trigger validation&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const nestedWizard = _.cloneDeep(wizardTestForm.form);

    wizard.setForm(formWithNestedWizard).then(() =&gt; {
      const nestedFormComp = wizard.getComponent(&apos;formNested&apos;);

      nestedFormComp.loadSubForm = ()=&gt; {
        nestedFormComp.formObj = nestedWizard;
        nestedFormComp.subFormLoading = false;
        return new Promise((resolve) =&gt; resolve(nestedWizard));
      };

      nestedFormComp.createSubForm();
      setTimeout(() =&gt; {
      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };

      checkPage(0);
      assert.equal(wizard.pages.length, 5, &apos;Should have 5 pages&apos;);
      assert.equal(wizard.allPages.length, 5, &apos;Should have 5 pages&apos;);
      assert.equal(wizard.refs[`${wizard.wizardKey}-link`].length, 5, &apos;Should contain refs to breadcrumbs of parent and nested wizard&apos;);

      clickWizardBtn(&apos;next&apos;);

      setTimeout(() =&gt; {
        checkPage(1);
        assert.equal(wizard.refs[`${wizard.wizardKey}`].querySelectorAll(&apos;[ref=&quot;component&quot;]&apos;).length, 1, &apos;Should not load nested wizard component of the page of nested form if this page contains other components&apos;);
        clickWizardBtn(&apos;next&apos;);

        setTimeout(() =&gt; {
          checkPage(2);
          assert.equal(wizard.refs[`${wizard.wizardKey}`].querySelectorAll(&apos;[ref=&quot;component&quot;]&apos;).length, 4, &apos;Should render nested wizard first page components&apos;);

          clickWizardBtn(&apos;next&apos;);

          setTimeout(() =&gt; {
            checkPage(2);
            assert.equal(wizard.errors.length, 1, &apos;Should show validation error for required field&apos;);
            assert.equal(wizard.refs.errorRef.length, 1, &apos;Should show alert with error&apos;);
            clickWizardBtn(&apos;previous&apos;);

            setTimeout(() =&gt; {
              checkPage(1);
              assert.equal(wizard.errors.length, 0, &apos;Should not have validation errors&apos;);

              clickWizardBtn(&apos;link[4]&apos;);

              setTimeout(() =&gt; {
                checkPage(4);
                assert.equal(!!wizard.refs[`${wizard.wizardKey}-submit`], true, &apos;Should have submit btn on the last page&apos;);
                clickWizardBtn(&apos;submit&apos;);

                setTimeout(() =&gt; {
                  checkPage(4);
                  assert.equal(wizard.errors.length, 3, &apos;Should trigger validation errors on submit&apos;);
                  assert.equal(wizard.refs.errorRef.length, 3, &apos;Should show alert with error on submit&apos;);
                  wizard.getComponent(&apos;select&apos;).setValue(&apos;value1&apos;);
                  setTimeout(() =&gt; {
                    checkPage(4);
                    assert.equal(wizard.errors.length, 2, &apos;Should remove validation error if a component is valid&apos;);
                    assert.equal(wizard.refs.errorRef.length, 2, &apos;Should remove error from alert if component is valid&apos;);

                    done();
                  }, 500);
                }, 500);
              }, 200);
            }, 200);
          }, 200);
        }, 200);
      }, 200);
    }, 200);
    })
    .catch((err) =&gt; done(err));
  }).timeout(3000);

  it(&apos;Should set submission in wizard with nested wizard&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const nestedWizard = _.cloneDeep(wizardTestForm.form);
    const submission = {
      data: {
        selectBoxesParent: {
          a: true,
          b: false,
          c: false
        },
        formNested: {
          data: wizardTestForm.submission.data
        },
        numberParent: 1111
      }
    };

    wizard.setForm(formWithNestedWizard).then(() =&gt; {
      const nestedFormComp = wizard.getComponent(&apos;formNested&apos;);

      nestedFormComp.loadSubForm = ()=&gt; {
        nestedFormComp.formObj = nestedWizard;
        nestedFormComp.subFormLoading = false;
        return new Promise((resolve) =&gt; resolve(nestedWizard));
      };

      nestedFormComp.createSubForm();

      setTimeout(() =&gt; {
      wizard.submission = _.cloneDeep(submission);

      setTimeout(() =&gt; {
        assert.deepEqual(wizard.data, submission.data, &apos;Should set wizard submission&apos;);
        assert.deepEqual(wizard.submission.data, submission.data, &apos;Should get wizard submission data&apos;);

        wizard.everyComponent((comp) =&gt; {
          const expectedValue = _.get(submission.data, comp.path, &apos;no data&apos;);

          if (expectedValue !== &apos;no data&apos;) {
            assert.deepEqual(comp.getValue(), expectedValue, `Should set value for ${comp.component.type} inside wizard`);
            assert.deepEqual(comp.dataValue, expectedValue, `Should set value for ${comp.component.type} inside wizard`);
          }
        });

        done();
      }, 300);
    }, 300);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should show conditional page inside nested wizard&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const nestedWizard = _.cloneDeep(wizardTestForm.form);
    nestedWizard.components[2].conditional = { show: true, when: &apos;checkbox&apos;, eq: &apos;true&apos; };

    wizard.setForm(formWithNestedWizard).then(() =&gt; {
      const nestedFormComp = wizard.getComponent(&apos;formNested&apos;);

      nestedFormComp.loadSubForm = ()=&gt; {
        nestedFormComp.formObj = nestedWizard;
        nestedFormComp.subFormLoading = false;
        return new Promise((resolve) =&gt; resolve(nestedWizard));
      };

      nestedFormComp.createSubForm();

      setTimeout(() =&gt; {
      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };

      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      checkPage(0);
      assert.equal(wizard.pages.length, 4, &apos;Should have 4 pages&apos;);
      assert.equal(wizard.allPages.length, 4, &apos;Should have 4 pages&apos;);
      assert.equal(wizard.refs[`${wizard.wizardKey}-link`].length, 4, &apos;Should contain refs to breadcrumbs of parent and nested wizard&apos;);

      clickWizardBtn(&apos;link[3]&apos;);

      setTimeout(() =&gt; {
        checkPage(3);

        assert.deepEqual(!!wizard.refs[`${wizard.wizardKey}-submit`], true, &apos;Should hav submit btn on the last page&apos;);
        wizard.getComponent(&apos;checkbox&apos;).setValue(true);

        setTimeout(() =&gt; {
          checkPage(3);

          assert.deepEqual(!!wizard.refs[`${wizard.wizardKey}-submit`], true, &apos;Should have submit btn on the last page&apos;);
          wizard.getComponent(&apos;checkbox&apos;).setValue(true);

          setTimeout(() =&gt; {
            checkPage(3);
            assert.deepEqual(!!wizard.refs[`${wizard.wizardKey}-submit`], false, &apos;Should not have submit btn &apos;);
            assert.equal(wizard.pages.length, 5, &apos;Should show conditional page&apos;);
            assert.equal(wizard.allPages.length, 5, &apos;Should show conditional page&apos;);
            assert.equal(wizard.refs[`${wizard.wizardKey}-link`].length, 5, &apos;Should contain refs to breadcrumbs of visible conditional page&apos;);

            clickWizardBtn(&apos;next&apos;);

            setTimeout(() =&gt; {
              checkPage(4);
              clickWizardBtn(&apos;previous&apos;);

              setTimeout(() =&gt; {
                checkPage(3);
                wizard.getComponent(&apos;checkbox&apos;).setValue(false);

                setTimeout(() =&gt; {
                  assert.equal(wizard.pages.length, 4, &apos;Should hide conditional page&apos;);
                  assert.equal(wizard.allPages.length, 4, &apos;Should hide conditional page&apos;);
                  assert.equal(wizard.refs[`${wizard.wizardKey}-link`].length, 4, &apos;Should contain refs to breadcrumbs of visible pages&apos;);
                  assert.deepEqual(!!wizard.refs[`${wizard.wizardKey}-submit`], true, &apos;Should have submit btn on the last page&apos;);

                  done();
                }, 500);
              }, 300);
            }, 300);
          }, 500);
        }, 300);
      }, 300);
    }, 300);
    })
    .catch((err) =&gt; done(err));
  }).timeout(3000);

  it(&apos;Should render values in HTML render mode&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement, {
      readOnly: true,
      renderMode: &apos;html&apos;
    });
    const form = _.cloneDeep(wizardTestForm.form);

    wizard.setForm(form, ).then(() =&gt; {
      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };

      const checkValues = () =&gt; {
        wizard.allPages[wizard.page].everyComponent((comp) =&gt; {
          const isParent = !!(comp.component.components || comp.component.rows || comp.component.columns);

          if (!isParent) {
            const isInEditGrid = comp.parent.component.type === &apos;editgrid&apos;;
            const value = isInEditGrid ? comp.parent.refs[&apos;editgrid-editGrid-row&apos;][comp.rowIndex].textContent.trim() : comp.element.querySelector(&quot;[ref=&apos;value&apos;]&quot;).textContent;
            const expectedValue = _.get(wizardTestForm.htmlModeValues, comp.path, &apos;no data&apos;);

            assert.equal(value, expectedValue === &apos;true&apos; ?  &apos;True&apos; : expectedValue, `${comp.component.key}: should render value in html render mode`);
          }
        });
      };

      wizard.submission = _.cloneDeep(wizardTestForm.submission);

      setTimeout(() =&gt; {
        checkPage(0);
        checkValues();
        clickWizardBtn(&apos;next&apos;);

        setTimeout(() =&gt; {
          checkPage(1);
          checkValues();
          clickWizardBtn(&apos;next&apos;);

          setTimeout(() =&gt; {
            checkPage(2);
            checkValues();
            done();
          }, 200);
        }, 200);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should execute advanced logic for wizard pages&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const form = _.cloneDeep(wizardTestForm.form);
    _.each(form.components, (comp, index) =&gt; {
      if (index === 1) {
        comp.logic = [
          {
            name: &apos;simple logic&apos;,
            trigger: { type: &apos;simple&apos;, simple: { show: true, when: &apos;textField&apos;, eq: &apos;tooltip&apos; } },
            actions: [
              {
                name: &apos;merge schema action&apos;,
                type: &apos;mergeComponentSchema&apos;,
                schemaDefinition: &quot;schema = { tooltip: &apos;some tooltip&apos;}&quot;
              }
            ]
          }
        ];
       }
      if (index === 2) {
        comp.logic = [
          {
            name: &apos;logic test&apos;,
            trigger: { type: &apos;simple&apos;, simple: { show: true, when: &apos;checkbox&apos;, eq: &apos;true&apos; } },
            actions: [
              {
                name: &apos;disabled&apos;,
                type: &apos;property&apos;,
                property: { label: &apos;Disabled&apos;, value: &apos;disabled&apos;, type: &apos;boolean&apos; },
                state: true
              }
            ]
          }
        ];
      }
     });

    wizard.setForm(form).then(() =&gt; {
      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };

      checkPage(0);
      wizard.getComponent(&apos;textField&apos;).setValue(&apos;tooltip&apos;);
      clickWizardBtn(&apos;next&apos;);

      setTimeout(() =&gt; {
        checkPage(1);
        assert.equal(wizard.tooltips.length, 1, &apos;Should have tooltip after advanced logic execution&apos;);
        assert.equal(!!wizard.refs[`${wizard.wizardKey}-tooltip`][0], true, &apos;Should render tooltip icon&apos;);

        wizard.getComponent(&apos;checkbox&apos;).setValue(true);
        clickWizardBtn(&apos;next&apos;);

        setTimeout(() =&gt; {
          checkPage(2);
          assert.equal(wizard.allPages[wizard.page].disabled, true, &apos;Should disable page components after advanced logic execution&apos;);
          done();
        }, 200);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should navigate next page according to advanced next page logic&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const form = _.cloneDeep(wizardTestForm.form);
    _.each(form.components, (comp, index) =&gt; {
      if (index === 0) {
        comp.nextPage = &quot;next = data.textField === &apos;page3&apos; ? &apos;page3&apos; : &apos;page2&apos;&quot;;
      }
      if (index === 1) {
        comp.nextPage = &quot;next = data.container &amp;&amp; data.container.select === &apos;value1&apos; ? &apos;page1&apos; : &apos;page3&apos;&quot;;
      }
     });

    wizard.setForm(form).then(() =&gt; {
      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };
      checkPage(0);
      wizard.getComponent(&apos;textField&apos;).setValue(&apos;page3&apos;);
      clickWizardBtn(&apos;next&apos;);

      setTimeout(() =&gt; {
        checkPage(2);
        wizard.getComponent(&apos;select&apos;).setValue(&apos;value1&apos;);
        clickWizardBtn(&apos;previous&apos;);

        setTimeout(() =&gt; {
          checkPage(1);
          wizard.getComponent(&apos;checkbox&apos;).setValue(true);
          clickWizardBtn(&apos;next&apos;);

          setTimeout(() =&gt; {
            checkPage(0);
            done();
          }, 200);
        }, 200);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should not render breadcrumb if it has hidden type&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const form = _.cloneDeep(wizardTestForm.form);
    _.each(form.components, (comp) =&gt; {
      comp.breadcrumb = &apos;none&apos;;
    });

    wizard.setForm(form).then(() =&gt; {
      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };

      const checkBreadcrumb = () =&gt; {
        assert.equal(_.get(wizard.refs, `${wizard.wizardKey}-link`).length, 0, &apos;Should not render wizard breadcrumb&apos;);
      };

      checkBreadcrumb();
      wizard.setSubmission(_.cloneDeep(wizardTestForm.submission));

      setTimeout(() =&gt; {
        checkPage(0);
        checkBreadcrumb();
        clickWizardBtn(&apos;next&apos;);

        setTimeout(() =&gt; {
          checkPage(1);
          checkBreadcrumb();
          clickWizardBtn(&apos;next&apos;);

          setTimeout(() =&gt; {
            checkPage(2);
            checkBreadcrumb();
            done();
          }, 100);
        }, 100);
      }, 100);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should not navigate between wizard pages on breadcrumb click if breadcrumbClickable is false&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const form = _.cloneDeep(wizardTestForm.form);
    _.each(form.components, (comp) =&gt; {
      comp.breadcrumbClickable = false;
    });

    wizard.setForm(form).then(() =&gt; {
      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };

      checkPage(0);
      clickWizardBtn(&apos;link[1]&apos;);

      setTimeout(() =&gt; {
        checkPage(0);
        clickWizardBtn(&apos;link[2]&apos;);

        setTimeout(() =&gt; {
          checkPage(0);
          wizard.setSubmission(_.cloneDeep(wizardTestForm.submission));

          setTimeout(() =&gt; {
            checkPage(0);
            clickWizardBtn(&apos;next&apos;);

            setTimeout(() =&gt; {
              checkPage(1);
              clickWizardBtn(&apos;link[0]&apos;);

              setTimeout(() =&gt; {
                checkPage(1);
                done();
              }, 100);
            }, 100);
          }, 100);
        }, 100);
      }, 100);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should set/get wizard submission&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);

    wizard.setForm(wizardTestForm.form).then(() =&gt; {
      wizard.submission = _.cloneDeep(wizardTestForm.submission);

      setTimeout(() =&gt; {
        assert.deepEqual(wizard.data, wizardTestForm.submission.data, &apos;Should set wizard submission&apos;);
        assert.deepEqual(wizard.submission.data, wizardTestForm.submission.data, &apos;Should get wizard submission data&apos;);

        wizard.everyComponent((comp) =&gt; {
          const expectedValue = _.get(wizardTestForm.submission.data, comp.path, &apos;no data&apos;);
          if (expectedValue !== &apos;no data&apos;) {
            assert.deepEqual(comp.getValue(), expectedValue, `Should set value for ${comp.component.type} inside wizard`);
            assert.deepEqual(comp.dataValue, expectedValue, `Should set value for ${comp.component.type} inside wizard`);
          }
        });
        done();
      }, 300);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should correctly render customized wizard and navigate using custom btns&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const customizedWizard = new Wizard(formElement);

    customizedWizard.setForm(customWizard).then(() =&gt; {
      customizedWizard.on(&apos;goToNextPage&apos;, function() {
        customizedWizard.nextPage();
      });
      customizedWizard.on(&apos;goToPrevPage&apos;, function() {
        customizedWizard.prevPage();
      });

      const checkBtns = (page) =&gt; {
        assert.equal(customizedWizard.page, page, `Should set page ${page + 1}`);
        assert.equal(!!customizedWizard.refs[`${customizedWizard.wizardKey}-next`], false, &apos;Should not render wizard next btn&apos;);
        assert.equal(!!customizedWizard.refs[`${customizedWizard.wizardKey}-cancel`], false, &apos;Should not render wizard cancel btn&apos;);
        assert.equal(!!customizedWizard.refs[`${customizedWizard.wizardKey}-previous`], false, &apos;Should not render wizard previous btn&apos;);
      };

      const navigatePage = (btnKey) =&gt; {
        const customBtn = customizedWizard.components[customizedWizard.page].getComponent(btnKey).refs.button;
        const clickEvent = new Event(&apos;click&apos;);
        customBtn.dispatchEvent(clickEvent);
      };
      checkBtns(0);
      navigatePage(&apos;nextPage&apos;);
      setTimeout(() =&gt; {
        checkBtns(1);
        navigatePage(&apos;nextPage1&apos;);
        setTimeout(() =&gt; {
          checkBtns(2);
          navigatePage(&apos;prevPage1&apos;);

          setTimeout(() =&gt; {
            checkBtns(1);
            navigatePage(&apos;prevPage&apos;);

            setTimeout(() =&gt; {
              checkBtns(0);
              customizedWizard.destroy();

              done();
            }, 200);
          }, 200);
        }, 200);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should not create a new submission on submission of edited draft submission&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const customizedWizard = new Wizard(formElement);
    const expectedValues = {
      &apos;1&apos;: {
        method: &apos;post&apos;,
        urlEnd: &apos;submission&apos;,
        state: &apos;draft&apos;,
        data: {
          number: undefined,
          textArea1: &apos;&apos;,
          textField: &apos;test&apos;
        },
        id: undefined
      },
      &apos;2&apos;: {
        method: &apos;put&apos;,
        urlEnd: &apos;someId&apos;,
        state: &apos;draft&apos;,
        data: {
          number: 111111,
          textArea1: &apos;test1&apos;,
          textField: &apos;test1&apos;
        },
        id: &apos;someId&apos;
      },
      &apos;3&apos;: {
        method: &apos;put&apos;,
        urlEnd: &apos;someId&apos;,
        state: &apos;draft&apos;,
        data: {
          number: 22222,
          textArea1: &apos;test&apos;,
          textField: &apos;test1&apos;
        },
        id: &apos;someId&apos;
      },
      &apos;4&apos;: {
        method: &apos;put&apos;,
        urlEnd: &apos;someId&apos;,
        state: &apos;draft&apos;,
        data: {
          number: 22222,
          textArea1: &apos;test1&apos;,
          textField: &apos;test1&apos;
        },
        id: &apos;someId&apos;
      },
      &apos;5&apos;: {
        method: &apos;put&apos;,
        urlEnd: &apos;someId&apos;,
        state: &apos;submitted&apos;,
        data: {
          number: 22222,
          textArea1: &apos;test1&apos;,
          textField: &apos;test1&apos;
        },
        id: &apos;someId&apos;
      }
    };

    customizedWizard.setForm(customWizard).then(() =&gt; {
      const formio = new Formio(&apos;http://test.localhost/draftwizardpages&apos;, {});
      let number = 1;

      formio.makeRequest = (type, url, method, data) =&gt; {
        assert.equal(method, expectedValues[number].method, `Should send ${expectedValues[number].method} request`);
        assert.equal(data._id, expectedValues[number].id, `Submission data should ${expectedValues[number].id ? &apos;&apos; : &apos;not&apos;} contain id of editted submission`);
        assert.equal(url.endsWith(expectedValues[number].urlEnd), true, `Request url should end with ${expectedValues[number].urlEnd}`);
        assert.equal(data.state, expectedValues[number].state, `Should set ${expectedValues[number].state} state for submission`);
        _.each(expectedValues[number].data, function(value, key) {
          assert.equal(data.data[key], value, `${key} field should contain &quot;${value}&quot; value in submission object`);
        });

        number = number + 1;

        return new Promise(resolve =&gt; resolve({
          _id: &apos;someId&apos;,
          data: {
            number: 22222,
            textArea1: &apos;test1&apos;,
            textField: &apos;test1&apos;
          },
          metadata:{},
          state: data.state
          })
        );
      };

      customizedWizard.formio = formio;

      customizedWizard.on(&apos;goToNextPage&apos;, function() {
        customizedWizard.executeSubmit({ state: &apos;draft&apos; }).then(() =&gt; customizedWizard.nextPage());
      });
      customizedWizard.on(&apos;goToPrevPage&apos;, function() {
        customizedWizard.executeSubmit({ state: &apos;draft&apos; }).then(() =&gt; customizedWizard.prevPage());
      });
      customizedWizard.on(&apos;saveSubmission&apos;, function() {
        customizedWizard.executeSubmit();
      });

      const checkPage = (page) =&gt; {
        assert.equal(customizedWizard.page, page, `Should set page ${page + 1}`);
      };

      const navigatePage = (btnKey) =&gt; {
        const customBtn = customizedWizard.components[customizedWizard.page].getComponent(btnKey).refs.button;
        const clickEvent = new Event(&apos;click&apos;);
        customBtn.dispatchEvent(clickEvent);
      };

      const setPageCompValue = (compKey, value) =&gt; {
        customizedWizard.components[customizedWizard.page].getComponent(compKey).setValue(value);
      };

      checkPage(0);
      setPageCompValue(&apos;textField&apos;, &apos;test&apos;);
      navigatePage(&apos;nextPage&apos;);

      setTimeout(() =&gt; {
        checkPage(1);
        setPageCompValue(&apos;number&apos;, 111111);
        navigatePage(&apos;nextPage1&apos;);

        setTimeout(() =&gt; {
          checkPage(2);
          setPageCompValue(&apos;textArea1&apos;, &apos;test&apos;);
          navigatePage(&apos;prevPage1&apos;);

          setTimeout(() =&gt; {
            checkPage(1);
            navigatePage(&apos;nextPage1&apos;);

            setTimeout(() =&gt; {
              checkPage(2);
              navigatePage(&apos;save&apos;);
              setTimeout(() =&gt; {
                customizedWizard.destroy();
                done();
              }, 200);
            }, 200);
          }, 200);
        }, 200);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should show validation alert and components` errors and navigate pages after clicking alert error&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);

    wizard.setForm(wizardTestForm.form).then(() =&gt; {
      const clickWizardBtn = (pathPart, clickError) =&gt; {
        const btn = _.get(wizard.refs, clickError ? pathPart : `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };

      const checkInvalidComp = (compKey, highLight) =&gt; {
        const comp = wizard.getComponent(compKey);

        assert.deepEqual(!!comp.error, true, `${compKey}: should have error`);
        assert.deepEqual(comp.error.message, `${comp.component.label} is required`, `${compKey}: should have correct required validation message`);
        assert.deepEqual(comp.pristine, false, `${compKey}: should set pristine to false`);
        assert.deepEqual(comp.element.classList.contains(`${highLight ? &apos;formio-error-wrapper&apos; : &apos;has-error&apos;}`), true, `${compKey}: should set error class`);
        assert.deepEqual(comp.refs.messageContainer.querySelector(&apos;.error&apos;).textContent.trim(), `${comp.component.label} is required`, `${compKey}: should display error message`);
      };

      checkPage(0);
      clickWizardBtn(&apos;link[2]&apos;);

      setTimeout(() =&gt; {
        checkPage(2);
        assert.equal(wizard.errors.length, 0, &apos;Should not have validation errors&apos;);

        clickWizardBtn(&apos;submit&apos;);

        setTimeout(() =&gt; {
          assert.equal(wizard.errors.length, 3, &apos;Should have validation errors&apos;);
          assert.equal(wizard.refs.errorRef.length, wizard.errors.length, &apos;Should show alert with validation errors&apos;);
          assert.equal(!!wizard.element.querySelector(&apos;.alert-danger&apos;), true, &apos;Should have alert with validation errors&apos;);
          checkInvalidComp(&apos;select&apos;, true);
          clickWizardBtn(&apos;errorRef[0]&apos;, true);

          setTimeout(() =&gt; {
            checkPage(0);

            assert.equal(wizard.errors.length, 1, &apos;Should have page validation error&apos;);
            assert.equal(wizard.refs.errorRef.length, 3, &apos;Should keep alert with validation errors&apos;);
            checkInvalidComp(&apos;textField&apos;);
            clickWizardBtn(&apos;errorRef[1]&apos;, true);

            setTimeout(() =&gt; {
              checkPage(1);

              assert.equal(wizard.errors.length, 1, &apos;Should have page validation error&apos;);
              assert.equal(wizard.refs.errorRef.length, 3, &apos;Should keep alert with validation errors&apos;);
              checkInvalidComp(&apos;checkbox&apos;);
              wizard.getComponent(&apos;checkbox&apos;).setValue(true);

              setTimeout(() =&gt; {
                checkPage(1);
                assert.equal(wizard.errors.length, 0, &apos;Should not have page validation error&apos;);
                assert.equal(wizard.refs.errorRef.length, 2, &apos;Should keep alert with validation errors&apos;);
                clickWizardBtn(&apos;errorRef[1]&apos;, true);

                setTimeout(() =&gt; {
                  checkPage(2);

                  assert.equal(wizard.errors.length, 2, &apos;Should have wizard validation errors&apos;);
                  assert.equal(wizard.refs.errorRef.length, 2, &apos;Should keep alert with validation errors&apos;);
                  wizard.getComponent(&apos;select&apos;).setValue(&apos;value1&apos;);

                  setTimeout(() =&gt; {
                    assert.equal(wizard.errors.length, 1, &apos;Should have wizard validation error&apos;);
                    assert.equal(wizard.refs.errorRef.length, 1, &apos;Should keep alert with validation errors&apos;);
                    clickWizardBtn(&apos;errorRef[0]&apos;, true);

                    setTimeout(() =&gt; {
                      checkPage(0);

                      assert.equal(wizard.errors.length, 1, &apos;Should have page validation error&apos;);
                      assert.equal(wizard.refs.errorRef.length, 1, &apos;Should keep alert with validation errors&apos;);
                      wizard.getComponent(&apos;textField&apos;).setValue(&apos;valid&apos;);

                      setTimeout(() =&gt; {
                        assert.equal(wizard.errors.length, 0, &apos;Should not have page validation error&apos;);
                        assert.equal(!!wizard.element.querySelector(&apos;.alert-danger&apos;), false, &apos;Should not have alert with validation errors&apos;);
                        clickWizardBtn(&apos;link[2]&apos;);

                        setTimeout(() =&gt; {
                          clickWizardBtn(&apos;submit&apos;);
                          setTimeout(() =&gt; {
                            assert.equal(wizard.submission.state, &apos;submitted&apos;, &apos;Should submit the form&apos;);
                            done();
                          }, 300);
                        }, 300);
                      }, 300);
                    }, 300);
                  }, 300);
                }, 300);
              }, 300);
            }, 100);
          }, 100);
        }, 100);
      }, 100);
    })
    .catch((err) =&gt; done(err));
  }).timeout(3500);

  it(&apos;Should navigate wizard pages using navigation buttons and breadcrumbs&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);

    wizard.setForm(wizardTestForm.form).then(() =&gt; {
      const clickNavigationBtn = (pathPart) =&gt; {
        const btn = _.get(wizard.refs, `${wizard.wizardKey}-${pathPart}`);
        const clickEvent = new Event(&apos;click&apos;);
        btn.dispatchEvent(clickEvent);
      };

      const checkPage = (pageNumber) =&gt; {
        assert.equal(wizard.page, pageNumber, `Should open wizard page ${pageNumber + 1}`);
      };
      checkPage(0);
      clickNavigationBtn(&apos;next&apos;);

      setTimeout(() =&gt; {
        checkPage(0);

        assert.equal(wizard.errors.length, 1, &apos;Should have validation error&apos;);
        assert.equal(wizard.refs.errorRef.length, wizard.errors.length, &apos;Should show alert with validation error&apos;);

        wizard.getComponent(&apos;textField&apos;).setValue(&apos;valid&apos;);

        clickNavigationBtn(&apos;next&apos;);

        setTimeout(() =&gt; {
          checkPage(1);
          clickNavigationBtn(&apos;next&apos;);

          setTimeout(() =&gt; {
            checkPage(1);

            assert.equal(wizard.errors.length, 1, &apos;Should have validation error&apos;);
            assert.equal(wizard.refs.errorRef.length, wizard.errors.length, &apos;Should show alert with validation error&apos;);

            clickNavigationBtn(&apos;previous&apos;);

            setTimeout(() =&gt; {
              checkPage(0);

              assert.equal(wizard.errors.length, 0, &apos;Should not have validation error&apos;);
              assert.equal(!!wizard.refs.errorRef, false, &apos;Should not have alert with validation error&apos;);

              clickNavigationBtn(&apos;next&apos;);

              setTimeout(() =&gt; {
                checkPage(1);
                assert.equal(wizard.errors.length, 1, &apos;Should have validation error&apos;);
                wizard.getComponent(&apos;checkbox&apos;).setValue(true);

                clickNavigationBtn(&apos;next&apos;);

                setTimeout(() =&gt; {
                  checkPage(2);
                  assert.equal(wizard.errors.length, 0, &apos;Should not have validation error&apos;);
                  clickNavigationBtn(&apos;link[0]&apos;);

                  setTimeout(() =&gt; {
                    checkPage(0);
                    assert.equal(wizard.errors.length, 0, &apos;Should not have validation error&apos;);
                    clickNavigationBtn(&apos;link[2]&apos;);

                    setTimeout(() =&gt; {
                      checkPage(2);
                      done();
                    }, 50);
                  }, 50);
                }, 50);
              }, 50);
            }, 50);
          }, 50);
        }, 50);
      }, 50);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should correctly set values in HTML render mode&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const formHTMLMode = new Wizard(formElement, {
      readOnly: true,
      renderMode: &apos;html&apos;
    });

    formHTMLMode.setForm(wizardForHtmlModeTest.form).then(() =&gt; {
      formHTMLMode.setSubmission(wizardForHtmlModeTest.submission);

      setTimeout(() =&gt; {
        const numberValue = formHTMLMode.element.querySelector(&apos;[ref=&quot;value&quot;]&apos;).textContent;
        assert.equal(+numberValue, wizardForHtmlModeTest.submission.data.number);

        const nextPageBtn = formHTMLMode.refs[`${formHTMLMode.wizardKey}-next`];
        const clickEvent = new Event(&apos;click&apos;);
        nextPageBtn.dispatchEvent(clickEvent);

        setTimeout(() =&gt; {
          const textValue = formHTMLMode.element.querySelector(&apos;[ref=&quot;value&quot;]&apos;).textContent;
          assert.equal(textValue, wizardForHtmlModeTest.submission.data.textField);

          done();
        }, 250);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should show tooltip for wizard pages&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizardWithPageTooltip = new Wizard(formElement);

    wizardWithPageTooltip.setForm(wizardWithTooltip).then(() =&gt; {
      const clickEvent = new Event(&apos;click&apos;);

      assert.equal(wizardWithPageTooltip.tooltips.length, 1);

      const pageTooltipIcon = wizardWithPageTooltip.refs[`${wizardWithPageTooltip.wizardKey}-tooltip`][0];

      assert.equal(!!pageTooltipIcon, true);

      pageTooltipIcon.dispatchEvent(clickEvent);

      setTimeout(() =&gt; {
        const tooltipText = wizardWithPageTooltip.element.querySelector(&apos;.tooltip-inner&apos;).textContent;
        assert.equal(tooltipText, wizardWithPageTooltip.currentPanel.tooltip);

        done();
      }, 250);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should not clear wizard data when navigating between wizard pages with hidden panel&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const formWithHiddenPage = new Wizard(formElement);

    formWithHiddenPage.setForm(wizardWithHiddenPanel).then(() =&gt; {
      const clickEvent = new Event(&apos;click&apos;);
      const inputEvent = new Event(&apos;input&apos;);

      assert.equal(formWithHiddenPage.pages.length, 2);

      const page1Field = formWithHiddenPage.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;);

      page1Field.value = &apos;555&apos;;
      page1Field.dispatchEvent(inputEvent);

      setTimeout(() =&gt; {
        assert.equal(formWithHiddenPage.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;).value, 555);

        const nextPageBtn = formWithHiddenPage.refs[`${formWithHiddenPage.wizardKey}-next`];
        nextPageBtn.dispatchEvent(clickEvent);

        setTimeout(() =&gt; {
          assert.equal(formWithHiddenPage.page, 1);

          const prevPageBtn = formWithHiddenPage.refs[`${formWithHiddenPage.wizardKey}-previous`];
          prevPageBtn.dispatchEvent(clickEvent);

          setTimeout(() =&gt; {
            assert.equal(formWithHiddenPage.page, 0);
            assert.equal(formWithHiddenPage.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;).value, 555);

            done();
          }, 250);
        }, 200);
      }, 100);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should show signature submission in HTML render mode&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const formWithSignatureHTMLMode = new Wizard(formElement, {
      readOnly: true,
      renderMode: &apos;html&apos;
    });

    formWithSignatureHTMLMode.setForm(formWithSignature.form).then(() =&gt; {
      formWithSignatureHTMLMode.setSubmission(formWithSignature.submission);

      setTimeout(() =&gt; {
        const signatureImage = formWithSignatureHTMLMode.element.querySelector(&apos;[ref=&quot;signatureImage&quot;]&apos;);
        assert.equal(signatureImage.src === formWithSignature.submission.data.signature, true);

        done();
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should display conditional page after setting submission&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizardWithSimpleConditionalPage = new Wizard(formElement);

    wizardWithSimpleConditionalPage.setForm(wizard4).then(() =&gt; {
      setTimeout(() =&gt; {
        assert.equal(wizardWithSimpleConditionalPage.pages.length, 1);
        assert.equal(wizardWithSimpleConditionalPage.components.length, 1);
        const submissionData = { checkbox: true, number: 555 };
        wizardWithSimpleConditionalPage.setSubmission({ data:submissionData });

        setTimeout(() =&gt; {
          assert.equal(wizardWithSimpleConditionalPage.pages.length, 2);
          assert.equal(wizardWithSimpleConditionalPage.components.length, 2);
          assert.deepEqual(wizardWithSimpleConditionalPage.data, submissionData);
          done();
        }, 500);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should display submission data on page with custom conditional logic in readOnly&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizardWithCustomConditionalPage = new Wizard(formElement);

    wizardWithCustomConditionalPage.setForm(wizard5).then(() =&gt; {
      setTimeout(() =&gt; {
        wizardWithCustomConditionalPage.disabled = true;

        if (wizardWithCustomConditionalPage.options) {
          wizardWithCustomConditionalPage.options.readOnly = true;
        }
        else {
          wizardWithCustomConditionalPage.options = { readOnly: true };
        }

        setTimeout(() =&gt; {
          assert.equal(wizardWithCustomConditionalPage.pages.length, 1);
          assert.equal(wizardWithCustomConditionalPage.components.length, 1);

          const submissionData = { checkbox: true, number: 555 };

          wizardWithCustomConditionalPage.setSubmission({ data:submissionData });

          setTimeout(() =&gt; {
            assert.equal(wizardWithCustomConditionalPage.pages.length, 2);
            assert.equal(wizardWithCustomConditionalPage.components.length, 2);
            assert.deepEqual(wizardWithCustomConditionalPage.data, submissionData);

            const clickEvent = new Event(&apos;click&apos;);
            const secondPageBtn = wizardWithCustomConditionalPage.refs[`${wizardWithCustomConditionalPage.wizardKey}-link`][1];

            secondPageBtn.dispatchEvent(clickEvent);

            setTimeout(() =&gt; {
              assert.equal(wizardWithCustomConditionalPage.page, 1);

              const numberComponent = wizardWithCustomConditionalPage.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;);

              assert.equal(numberComponent.value, 555);

              done();
            }, 400);
          }, 300);
        }, 200);
      }, 100);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should show conditional wizard page&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizardWithConditionalPage = new Wizard(formElement);

    wizardWithConditionalPage.setForm(wizard3).then(() =&gt; {
      setTimeout(() =&gt; {
        assert.equal(wizardWithConditionalPage.pages.length, 1);
        assert.equal(wizardWithConditionalPage.components.length, 1);

        const inputEvent = new Event(&apos;input&apos;);
        const numberComponent = wizardWithConditionalPage.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;);

        numberComponent.value = 5;
        numberComponent.dispatchEvent(inputEvent);

        setTimeout(() =&gt; {
          assert.equal(wizardWithConditionalPage.pages.length, 2);
          assert.equal(wizardWithConditionalPage.components.length, 2);

          done();
        }, 300);
      }, 200);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should show first conditional wizard page&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);

    wizard.setForm(wizard6).then(() =&gt; {
      assert.equal(wizard.pages.length, 1);
      assert.equal(wizard.components.length, 1);
      assert.equal(wizard.page, 0);
      assert.equal(wizard.refs[`wizard-${wizard.id}-previous`], null);
      assert.equal(
        wizard.refs[
          `wizard-${wizard.id}-link`
        ][0].parentElement.classList.contains(&apos;active&apos;),
        true
      );
      wizard.setValue({
        data: { b: &apos;true&apos; },
      });
      setTimeout(() =&gt; {
        assert.equal(wizard.pages.length, 2);
        assert.equal(wizard.components.length, 2);
        assert.equal(wizard.page, 1);
        assert.notEqual(wizard.refs[`wizard-${wizard.id}-previous`], null);
        assert.equal(
          wizard.refs[
            `wizard-${wizard.id}-link`
          ][1].parentElement.classList.contains(&apos;active&apos;),
          true
        );
        done();
      }, 300);
    })
    .catch((err) =&gt; done(err));
  });

  it(&apos;Should display editGrid submission data in readOnly mode&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    const wizardForm = new Wizard(formElement, { readOnly: true });
    wizardForm.setForm(wizard2).then(() =&gt; {
      wizardForm.setValue({ data: { editGrid: [{ textField: &apos;111&apos; }], number: 222 } });
      setTimeout(() =&gt; {
        assert.equal(wizardForm.element.querySelector(&apos;[name=&quot;data[number]&quot;]&apos;).value, &apos;222&apos;);

        Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-link`][1]);

        setTimeout(() =&gt; {
          assert.equal(wizardForm.page, 1);

          const ditGridRowValue = wizardForm.element.querySelector(&apos;[ref = &quot;editgrid-editGrid-row&quot;]&apos;).querySelector(&apos;.col-sm-2&apos;).textContent.trim();
          assert.equal(ditGridRowValue, &apos;111&apos;);
          done();
        }, 300);
      }, 100);
    })
      .catch((err) =&gt; done(err));
  });

  let wizardForm = null;
  it(&apos;Should set components errors if they are after page was changed with navigation&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    wizardForm = new Wizard(formElement);
    wizardForm.setForm(wizard).then(() =&gt; {
      Harness.testErrors(wizardForm, {
        data: {
          a: &apos;1&apos;,
          c: &apos;&apos;,
          textField: &apos;&apos;
        }
      },
        [{
          component: &apos;a&apos;,
          message: &apos;a must have at least 4 characters.&apos;
        }], done);
      Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-link`][2]);
      assert.equal(wizardForm.page, 2);
      setTimeout(() =&gt; {
        Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-link`][0]);
        assert.equal(wizardForm.page, 0);
        setTimeout(() =&gt; {
          const aInput = wizardForm.currentPage.getComponent(&apos;a&apos;);
          assert.equal(aInput.errors.length, 1);
          assert.equal(aInput.errors[0].message, &apos;a must have at least 4 characters.&apos;);
          done();
        }, 100);
      }, 100);
    })
      .catch((err) =&gt; done(err));
  });

  it(&apos;Should leave errors for invalid fields after validation on next button and entering valid data in one of the fields&apos;, function(done) {
    const formElement = document.createElement(&apos;div&apos;);
    wizardForm = new Wizard(formElement);
    wizardForm.setForm(wizard1).then(() =&gt; {
      Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-next`]);
      setTimeout(() =&gt; {
        assert.equal(wizardForm.errors.length, 2);

        const inputEvent = new Event(&apos;input&apos;, { bubbles: true, cancelable: true });
        const inputA = formElement.querySelector(&apos;input[name=&quot;data[a]&quot;]&apos;);

        for (let i = 0; i &lt; 5; i++) {
          inputA.value += i;
          inputA.dispatchEvent(inputEvent);
        }

        setTimeout(() =&gt; {
          assert.equal(wizardForm.errors.length, 1);
          done();
        }, 250);
      }, 250);
    })
      .catch((err) =&gt; done(err));
  });

  it(&apos;Should not set components errors if in readOnly mode&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    wizardForm = new Wizard(formElement, { readOnly: true });
    wizardForm.setForm(wizard).then(() =&gt; {
      Harness.testSubmission(wizardForm, {
        data: {
          a: &apos;1&apos;,
          textField: &apos;aaa&apos;,
          c: &apos;0&apos;
        }
      });

      Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-link`][2]);
      assert.equal(wizardForm.page, 2);
      Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-link`][0]);
      assert.equal(wizardForm.page, 0);
      const aInput = wizardForm.currentPage.getComponent(&apos;a&apos;);
      assert.equal(aInput.errors.length, 0);
      done();
    });
  });

  it(&apos;Should keep values during validation that are conditionally visible&apos;, async() =&gt; {
    const submission = {
      data: {
        a: true,
        b: &apos;b&apos;,
        c: &apos;c&apos;
      }
    };

    const form = await Formio.createForm(wizardCond, {});

    form.validator.config = {
      db: {},
      token: &apos;&apos;,
      form: wizardCond,
      submission: submission
    };

    // Set the submission data
    form.data = submission.data;

    assert.deepEqual(form.data, submission.data, &apos;Should set data properly&apos;);
    // Perform calculations and conditions.
    form.calculateValue();
    form.checkConditions();

    assert(form.components[2], &apos;Should contain the 3rd page&apos;);
    assert.equal(form.components[2].visible, true, &apos;Should be visible&apos;);

    const textField = form.components[2].components[0];

    assert.equal(textField.visible, true, &apos;Inner components of the 3rd page should be visible&apos;);
    assert.equal(textField.parentVisible, true, &apos;parentVisible of the 3rd page\&apos;s child components should be equal to true&apos;);

    // Reset the data
    form.data = {};

    form.setValue(submission, {
      sanitize: true
    });

    // Check the validity of the form.
    const valid = await form.checkAsyncValidity(null, true);

    assert(valid, &apos;Should be valid&apos;);
    assert.equal(form.data.c, &apos;c&apos;, &apos;Should keep the value of a conditionally visible page.&apos;);
  });

  it(&apos;If allowPrevious is given, the breadcrumb bar should be clickable for visited tabs.&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    wizardForm = new Wizard(formElement, { allowPrevious: true });
    wizardForm.setForm(wizardWithAllowPrevious)
      .then(() =&gt; {
        Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-link`][1]);

        setTimeout(() =&gt; {
          assert.equal(wizardForm.page, 0, &apos;Should be disabled for unvisited tabs.&apos;);
          Harness.clickElement(wizardForm, wizardForm.refs[`${wizardForm.wizardKey}-next`]);

          setTimeout(() =&gt; {
            assert.equal(wizardForm.enabledIndex, 1, &apos;Should be clickable for visited tabs.&apos;);
            done();
          }, 100);
        }, 100);
      })
      .catch(done);
  });

  it(&apos;Should scroll to the top of the page when the page is changed&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    wizardForm = new Wizard(formElement);
    wizardForm.setForm(wizardWithHighPages)
      .then(() =&gt; {
        wizardForm.scrollIntoView(wizardForm.refs[`${wizardForm.wizardKey}-next`]);
        wizardForm.setPage(1);
        setTimeout(() =&gt; {
          assert.equal(wizardForm.refs[wizardForm.wizardKey].scrollTop, 0, &apos;The top edge of the page should be aligned to the top edge of the window&apos;);
          done();
        }, 350);
      })
      .catch(done);
  });

  it(&apos;Should show the actual page after re-rendering due to nested wizards.&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    wizardForm = new Wizard(formElement);
    wizardForm.setForm(wizardWithNestedWizard)
      .then(() =&gt; {
        wizardForm.setForm(wizardWithNestedWizard);

        setTimeout(() =&gt; {
          assert.equal(wizardForm.element.querySelector(&apos;.wizard-page&apos;), wizardForm.allPages[0].components[0].element.parentNode);
          done();
        }, 350);
      })
      .catch(done);
  });

  it(&apos;Should render all pages as a part of wizard pagination&apos;, (done) =&gt; {
    const formElement = document.createElement(&apos;div&apos;);
    const wizard = new Wizard(formElement);
    const childForm = _.cloneDeep(wizardChildForm);
    const clickEvent = new Event(&apos;click&apos;);

    wizard.setForm(wizardParentForm).then(() =&gt; {
      assert.equal(wizard.components.length, 2);
      assert.equal(wizard.allPages.length, 2);
      assert.equal(wizard.allPages[1].component.title, &apos;Page 3&apos;);

      const radioComp = wizard.getComponent(&apos;radio1&apos;);

      radioComp.setValue(&apos;yes&apos;);
      wizard.render();

      setTimeout(() =&gt; {
        const nestedFormComp = wizard.getComponent(&apos;formNested&apos;);
        nestedFormComp.loadSubForm = () =&gt; {
        nestedFormComp.formObj = childForm;
        nestedFormComp.subFormLoading = false;

          return new Promise((resolve) =&gt; resolve(childForm));
        };
        nestedFormComp.createSubForm();

        setTimeout(() =&gt; {
          assert.equal(wizard.components.length, 3);
          assert.equal(wizard.allPages.length, 4);
          assert.equal(wizard.allPages[1].component.title, &apos;Child Page 1&apos;);

          const checboxComp = wizard.getComponent(&apos;checkbox&apos;);

          checboxComp.setValue(true);
          wizard.render();

          setTimeout(() =&gt; {
            assert.equal(wizard.components.length, 3);
            assert.equal(wizard.allPages.length, 5);
            assert.equal(wizard.allPages[1].component.title, &apos;Page 2&apos;);
            assert.equal(wizard.element.querySelector(&apos;input[name=&quot;data[textFieldNearForm]&quot;]&apos;), null);

            const nextPageBtn = wizard.refs[`${wizard.wizardKey}-next`];

            nextPageBtn.dispatchEvent(clickEvent);

            setTimeout(() =&gt; {
              assert.equal(wizard.component.title, &apos;Page 2&apos;);
              assert.ok(wizard.element.querySelector(&apos;input[name=&quot;data[textFieldNearForm]&quot;]&apos;));

              done();
            }, 200);
          }, 200);
        }, 200);
      }, 200);
    }).catch(done);
  });
});
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
